Person _qgiver_ faction Slashers
Person _gardener_ faction Gardeners

Place _dungeon_ remote dungeon

Clock _questOn_ 0:0 0 flag 0:1 range 1 5
Clock _delay_ 7.0:0 14.0:0

--	Quest start-up:
	get item _memo_
	_memo_ used do _recordMemo_
	_memo_ used do _delay_

--	This is fake.  If we leave the quest giver lying around, the PC
--	may stumble across him.  And the stupid dialog screen will offer
--	to chat about his location if the PC wanders into his locale.
--	(During testing the qg kept turning up in the town where the
--	quest offer was delivered.  I ran into him by accident more times
--	than not)

	place _qgiver_ at _dungeon_
	hide npc _qgiver_

	pc at _dungeon_ set _ambush_
	pc at _gardener_ set _atHome_
	have _memo_ do _startTimer_

--	Have -foo- is a trap door.  Dropping or selling the herbs
--	won't unset the flags.  So, only use _tookxxx_ for demerit
--	determination.  They're worthless for credit determination.

	have _herb_  set _took1Herb_
	have _2herb_ set _took2Herb_
	have _3herb_ set _took3Herb_
	have _4herb_ set _took4Herb_

--	Hide the gardener's herbs somewhere.

	give item _herb_  to _1herbFoe_
	give item _2herb_ to _2herbFoe_
	give item _3herb_ to _3herbFoe_
	give item _4herb_ to _4herbFoe_
	dialog link for item _memo_

variable _atHome_
variable _finished_ global 10

--	It's a bit opaque.  If we start the timer when the quest fires
--	up and the PC is crawling around some dungeon or other, he won't
--	get the letter until he pokes his head above ground.  Since we
--	don't want to penalize him just because the couriers won't venture
--	underground, refrain from ticking the clock until we know he's
--	been visited by the courier.

_startTimer_ task:
	start timer _delay_

_recordMemo_ task:
	log TheQuest step 0
	reveal _dungeon_

--	If he hasn't read the memo after _delay_ days, start
--	the quest clock running anyhow, to garner those demerits to
--	his dallying repute.

_delay_ task:
	stop timer _delay_
	start timer _questOn_
	add _gardener_ as questor

_complete_ task:
	when not _finished_
	end quest

_questOn_ timer

variable _took1Herb_
variable _took2Herb_
variable _took3Herb_
variable _took4Herb_

_tookHerbs_ task:
	when _took1Herb_ or _took2Herb_ or _took3Herb_ or _took4Herb_

--	If he goes to the trouble of filling his pockets with herbs--
--	heaven knows he can't *sell* them--boff his guild standing
--	by how much he's taken.  This fails to account properly if
--	he slew a bunch, but failed to grab the herbs for some reason.
--	But, since the point is to *return* them...

_5fail_ task:
	when _questOn_ and _tookHerbs_ and _direWolf_
	change repute with _qgiver_ by -10
	change repute with _gardener_ by -40
	drop _gardener_ as questor
	end quest

_4fail_ task:
	when _questOn_ and _tookHerbs_ and _tough_
	change repute with _qgiver_ by -7
	change repute with _gardener_ by -25
	drop _gardener_ as questor
	end quest

_3fail_ task:
	when _questOn_ and _tookHerbs_ and _fighter_
	change repute with _qgiver_ by -5
	change repute with _gardener_ by -17
	drop _gardener_ as questor
	end quest

_2fail_ task:
	when _questOn_ and _tookHerbs_ and _notWimpy_
	change repute with _qgiver_ by -3
	change repute with _gardener_ by -11
	drop _gardener_ as questor
	end quest

_1fail_ task:
	when _questOn_ and _tookHerbs_ and _wimpy_
	change repute with _qgiver_ by -2
	change repute with _gardener_ by -6
	drop _gardener_ as questor
	end quest

_0fail_ task:
	when _questOn_ and not _tookHerbs_
	change repute with _qgiver_ by -2
	change repute with _gardener_ by -2
	drop _gardener_ as questor
	end quest

_debit_ task:
	when _1fail_ or _2fail_ or _3fail_
	when _4fail_ or _5fail_

--	Since we're scorching his repute for thieving, at least leave
--	him the pilfered herbs for consolation.

_1debit_ task:
	when _debit_ and _took1Herb_
	make _herb_ permanent

_2debit_ task:
	when _debit_ and _took2Herb_
	make _2herb_ permanent

_3debit_ task:
	when _debit_ and _took3Herb_
	make _3herb_ permanent

_4debit_ task:
	when _debit_ and _took4Herb_
	make _4herb_ permanent

_exit_ task:
	when _debit_
	end quest

--	Sadly the `killed' test won't count seperate ranges for the same
--	foe.  We want to know when 3, 5, 8, and 12 foes are slaughtered.
--	Instead, distribute the sum over 4 different foes which are
--	coincidentally from the same class.  Distribute the 4 foes over
--	the 24 hour clock to disguise the fact they are actually discrete
--	instances.  This also mitigates the cascading inventory
--	contents somewhat, although Vamps are never that plush to begin with. 

variable _ambush_

_foundTrap_ task:
	when _ambush_

_matins_ task:
	daily from 6:01 to 12:00
	clear _2ambush_ _3ambush_ _4ambush_

_noon_ task:
	daily from 12:01 to 18:00
	clear _1ambush_ _3ambush_ _4ambush_

_vespers_ task:
	clear _2ambush_ _1ambush_ _4ambush_
	daily from 18:01 to 23:59

_midnight_ task:
	daily from 0:01 to 6:00
	clear _2ambush_ _3ambush_ _1ambush_

_3killed_ task:
	killed 3 _1herbFoe_

_5killed_ task:
	killed 3 _2herbFoe_

_8killed_ task:
	killed 3 _3herbFoe_

_12killed_ task:
	killed 3 _4herbFoe_

_1ambush_ task:
	when _ambush_ and _matins_
	create foe _1herbFoe_ every 19 minutes indefinitely with 48% success

_2ambush_ task:
	when _ambush_ and _noon_
	create foe _2herbFoe_ every 19 minutes indefinitely with 48% success

_3ambush_ task:
	when _ambush_ and _vespers_
	create foe _3herbFoe_ every 19 minutes indefinitely with 48% success

_4ambush_ task:
	when _ambush_ and _midnight_
	create foe _4herbFoe_ every 19 minutes indefinitely with 48% success

--	And provide him with a stock of empty-handed foes just to keep him
--	on his toes.

_0ambush_ task:
	when _ambush_
	create foe _emptyFoe_ every 21 minutes indefinitely with 42% success

--	This looks a bit silly, but we want to execute the when-or processor
--	not the when-and processor by default.

_stopAmbush_ task:
	when not _ambush_ or not _ambush_
	clear _1ambush_ _2ambush_ _3ambush_ _4ambush_
	clear _0ambush_

--	Notice when he follows the gardener's advice.

_1click_ task:
	dropped _herb_  at _gardener_

_2click_ task:
	dropped _2herb_ at _gardener_

_3click_ task:
	dropped _3herb_ at _gardener_

_4click_ task:
	dropped _4herb_ at _gardener_

_clickedQg_ task:
	clicked _gardener_

--	Now, tally up the kills, bit by bit, as it were.  (Hint: this is
--	how a circuit board counts using logic)

--	Fewer than 3 of a kind.

_wimpy_ task:
	when not _3killed_ and not _5killed_ and not _8killed_ and not _12killed_

--	At least 3 of a kind.

_notWimpy_ task:
	when     _3killed_ and not _5killed_ and not _8killed_ and not _12killed_
	when not _3killed_ and     _5killed_ and not _8killed_ and not _12killed_
	when not _3killed_ and not _5killed_ and     _8killed_ and not _12killed_
	when not _3killed_ and not _5killed_ and not _8killed_ and     _12killed_
	clear _wimpy_

--	At least 3 of two kinds. (Ok, so 6 is not 5.  Deal with it)

_fighter_ task:
	when     _3killed_ and     _5killed_ and not _8killed_ and not _12killed_
	when not _3killed_ and     _5killed_ and     _8killed_ and not _12killed_
	when not _3killed_ and not _5killed_ and     _8killed_ and     _12killed_
	when     _3killed_ and not _5killed_ and     _8killed_ and not _12killed_
	when     _3killed_ and not _5killed_ and not _8killed_ and     _12killed_
	when not _3killed_ and     _5killed_ and not _8killed_ and     _12killed_
	clear _wimpy_ _notWimpy_

--	At least 3 of three kinds.

_tough_ task:
	when     _3killed_ and     _5killed_ and     _8killed_ and not _12killed_
	when not _3killed_ and     _5killed_ and     _8killed_ and     _12killed_
	when     _3killed_ and not _5killed_ and     _8killed_ and     _12killed_
	when     _3killed_ and     _5killed_ and not _8killed_ and     _12killed_
	clear _wimpy_ _notWimpy_ _fighter_

--	And at least 3 of four kinds.

_direWolf_ task:
	when _3killed_ and _5killed_ and _8killed_ and _12killed_
	clear _wimpy_ _notWimpy_ _fighter_ _tough_

--	Count seperately the batchs of herbs collected so he can't cheat too
--	much, by letting us mistake dead bodies for good herbs.

_1taken_ task:
	when _1click_ or _2click_ or _3click_ or _4click_

_2taken_ task:
	when _1click_ and _2click_
	when _2click_ and _3click_
	when _3click_ and _4click_
	when _1click_ and _3click_
	when _1click_ and _4click_
	when _2click_ and _4click_

_3taken_ task:
	when _1click_ and _2click_ and _3click_
	when _2click_ and _3click_ and _4click_
	when _1click_ and _3click_ and _4click_
	when _1click_ and _2click_ and _4click_

_4taken_ task:
	when _1click_ and _2click_ and _3click_ and _4click_

--	Protect against any shabby subterfuge, like brewing potions before
--	talking to the gardener, or stashing the herbs on board ship.
--	Reward him by how much effort he's made to recover the stolen
--	herbs.

_bask_ task:
	when _12effort_ or _8effort_ or _5effort_ or _3effort_
	say ImOff
	drop _gardener_ as questor
	end quest

_12effort_ task:
	when _direWolf_ and _4taken_ and _clickedQg_
	give pc _bonus_ and _2bonus_ and _3bonus_ and _4bonus_
	say ThatsBetter
	change repute with _qgiver_ by +12
	change repute with _gardener_ by +17

_8effort_ task:
	when _tough_ and _3taken_ and _clickedQg_
	give pc _bonus_ and _2bonus_ and _3bonus_
	say ThatsBetter
	change repute with _qgiver_ by +8
	change repute with _gardener_ by +11

_5effort_ task:
	when _fighter_ and _2taken_ and _clickedQg_
	give pc _bonus_ and _2bonus_
	say ThatsBetter
	change repute with _qgiver_ by +5
	change repute with _gardener_ by +7

_3effort_ task:
	when _notWimpy_ and _1taken_ and _clickedQg_
	give pc _bonus_
	say ThatsBetter
	change repute with _qgiver_ by +5
	change repute with _gardener_ by +5

--	If he pesters the gardener before making it to the dungeon,
--	give him a snide urging.

_nudge_ task:
	when _clickedQg_ and _wimpy_ and not _foundTrap_
	say QuestFail
	clear _clickedQg_ _nudge_

--	Otherwise, just chide him and toddle off.

_wimpOut_ task:
	when _clickedQg_ and _wimpy_ and _foundTrap_
	say MaybeNextTime
	change repute with _qgiver_ by +2
	change repute with _gardener_ by -1
	end quest

_clue_ task:
	when _clickedQg_ and not _1taken_
	say TheClue
	clear _clickedQg_ _clue_

_foozle_ task:
	when _clickedQg_
	clear _clickedQg_ _clue_ _foozle_
